<template>
  <v-card
    class="mx-auto"
  >
    <v-list-item class="survey-description">
      <v-list-item-content>
        <v-list-item-title class="headline">
          {{ $t('label.survey_description') }}
        </v-list-item-title>
      </v-list-item-content>
    </v-list-item>
    <ValidationObserver v-slot="{ validate, reset }" ref="observer">
      <form
        ref="form"
        lazy-validation
      >
        <ValidationProvider
          v-slot="{ errors }"
          :name="$t('label.name_survey')"
          rules="required|isHtml"
        >
          <v-text-field
            v-model="formSurvey.survey_name"
            :counter="150"
            :error-messages="errors"
            :label="$t('label.name_survey')"
            required
          />
        </ValidationProvider>
        <ValidationProvider v-slot="{ errors }" :name="$t('label.description')">
          <v-list>
            <v-list-item class="survey-description">
              <v-list-item-content>
                <v-list-item-title class="title">
                  {{ $t('label.description') }}
                </v-list-item-title>
              </v-list-item-content>
            </v-list-item>
          </v-list>
          <tinymce v-model="description" :height="100" />
        </ValidationProvider>
        <ValidationProvider v-slot="{ errors }" :name="$t('label.introduction')">
          <v-list>
            <v-list-item class="survey-description">
              <v-list-item-content>
                <v-list-item-title class="title">
                  {{ $t('label.introduction') }}
                </v-list-item-title>
              </v-list-item-content>
            </v-list-item>
          </v-list>
          <tinymce v-model="introduction" :height="100" />
        </ValidationProvider>
        <v-list>
          <v-list-item class="survey-description">
            <v-list-item-content>
              <v-list-item-title class="title">
                {{ $t('label.period') }}
              </v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-list>
        <v-row>
          <v-col>
            <InputDatePicker
              :label="$t('label.start_date')"
              :date-value="formSurvey.periode_start"
              :format-date="formatDate"
              @changeDate="formSurvey.periode_start = $event"
            />
          </v-col>
          <v-col>
            <InputDatePicker
              :label="$t('label.end_date')"
              :date-value="formSurvey.periode_end"
              :format-date="formatDate"
              @changeDate="formSurvey.periode_end = $event"
            />
          </v-col>
        </v-row>
        <v-list>
          <v-list-item class="survey-description">
            <v-list-item-content>
              <v-list-item-title class="title">
                {{ $t('label.targeted_respondent') }}
              </v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-list>
        <ValidationProvider v-slot="{ errors }" :name="$t('label.targeted_respondent')">
          <v-text-field
            v-model="formSurvey.respondent_target"
            :error-messages="errors"
            :placeholder="$t('label.input_responden_target')"
            type="number"
            required
          />
        </ValidationProvider>
        <v-container fluid>
          <v-row class="survey-bottom-form">
            <v-btn
              color="success"
              class="check-form"
              dark
              absolute
              bottom
              right
              @click="checkForm()"
            >
              {{ $t('label.continue') }}
            </v-btn>
          </v-row>
        </v-container>
      </form>
    </ValidationObserver>
  </v-card>
</template>

<script>
import InputDatePicker from '@/components/InputDatePicker'
import { ValidationObserver, ValidationProvider } from 'vee-validate'
import EventBus from '@/utils/eventBus'

export default {
  name: 'SurveyFormDescription',
  components: {
    ValidationProvider,
    ValidationObserver,
    InputDatePicker
  },
  props: {
    steps: {
      type: Number,
      default: null
    },
    formSurvey: {
      type: Object,
      default: null
    }
  },
  data: () => ({
    formatDate: 'DD-MM-YYYY',
    description: '',
    introduction: ''
  }),
  watch: {
    'description': function(val) {
      this.$store.dispatch('survey/setFormSurveyDescription', val)
    },
    'introduction': function(val) {
      this.$store.dispatch('survey/setFormSurveyIntroduction', val)
    }
  },
  mounted() {
    this.description = this.formSurvey.description
    this.introduction = this.formSurvey.introduction
  },
  methods: {
    async checkForm() {
      const valid = await this.$refs.observer.validate()
      let response
      if (!valid) {
        return
      } else if (this.formSurvey.periode_start.length < 1) {
        await this.$store.dispatch('toast/errorToast', this.$t('errors.start_date_period_cannot_be_empty'))
        return
      } else if (this.formSurvey.periode_end.length < 1) {
        await this.$store.dispatch('toast/errorToast', this.$t('errors.end_date_period_cannot_be_empty'))
        return
      }
      Object.assign(this.formSurvey, { status: 'Draft' })
      if (this.formSurvey.id !== null) {
        response = await this.$store.dispatch('survey/updateSurvey', this.formSurvey)
      } else {
        response = await this.$store.dispatch('survey/createSurvey', this.formSurvey)
      }
      if (response) {
        EventBus.$emit('nextSurveySteps', this.steps)
      }
    }
  }
}
</script>
<style scoped>
  .survey-bottom-form {
    padding-top: 50px;
  }
  .survey-description {
    padding: 0;
  }
</style>
